org.bouncycastle.crypto.modes

## Class CCMBlockCipher

- java.lang.Object
- - org.bouncycastle.crypto.modes.CCMBlockCipher

All Implemented Interfaces:
  AEADBlockCipher

    public class CCMBlockCipher
    extends java.lang.Object
    implements AEADBlockCipher

Implements the Counter with Cipher Block Chaining mode (CCM) detailed in NIST Special Publication 800-38C.

Note: this mode is a packet mode - it needs all the data up front.

### Constructor Summary

Constructors
Constructor and Description
`CCMBlockCipher(BlockCipher c)` Basic constructor.

### Method Summary

Methods
`int` `doFinal(byte[] out, int outOff)` Finish the operation either appending or verifying the MAC at the end of the data.
`java.lang.String` `getAlgorithmName()` Return the name of the algorithm.
`byte[]` `getMac()` Returns a byte array containing the mac calculated as part of the last encrypt or decrypt operation.
`int` `getOutputSize(int len)` return the size of the output buffer required for a processBytes plus a doFinal with an input of len bytes.
`BlockCipher` `getUnderlyingCipher()` return the underlying block cipher that we are wrapping.
`int` `getUpdateOutputSize(int len)` return the size of the output buffer required for a processBytes an input of len bytes.
`void` `init(boolean forEncryption, CipherParameters params)` initialise the underlying cipher.
`int` `processByte(byte in, byte[] out, int outOff)` encrypt/decrypt a single byte.
`int` `processBytes(byte[] in, int inOff, int inLen, byte[] out, int outOff)` process a block of bytes from in putting the result into out.
`byte[]` `processPacket(byte[] in, int inOff, int inLen)`
`void` `reset()` Reset the cipher.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CCMBlockCipher

    public CCMBlockCipher(BlockCipher c)

Basic constructor.

Parameters:
  `c` - the block cipher to be used.

### Method Detail

#### getUnderlyingCipher

    public BlockCipher getUnderlyingCipher()

return the underlying block cipher that we are wrapping.

Specified by:
  `getUnderlyingCipher` in interface `AEADBlockCipher`
Returns:
  the underlying block cipher that we are wrapping.

#### init

    public void init(boolean forEncryption,
            CipherParameters params)
              throws java.lang.IllegalArgumentException

Description copied from interface: `AEADBlockCipher`
initialise the underlying cipher. Parameter can either be an AEADParameters or a ParametersWithIV object.

Specified by:
  `init` in interface `AEADBlockCipher`
Parameters:
  `forEncryption` - true if we are setting up for encryption, false otherwise.
  `params` - the necessary parameters for the underlying cipher to be initialised.
Throws:
  `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

#### getAlgorithmName

    public java.lang.String getAlgorithmName()

Description copied from interface: `AEADBlockCipher`
Return the name of the algorithm.

Specified by:
  `getAlgorithmName` in interface `AEADBlockCipher`
Returns:
  the algorithm name.

#### processByte

    public int processByte(byte in,
                  byte[] out,
                  int outOff)
                    throws DataLengthException,
                           java.lang.IllegalStateException

Description copied from interface: `AEADBlockCipher`
encrypt/decrypt a single byte.

Specified by:
  `processByte` in interface `AEADBlockCipher`
Parameters:
  `in` - the byte to be processed.
  `out` - the output buffer the processed byte goes into.
  `outOff` - the offset into the output byte array the processed data starts at.
Returns:
  the number of bytes written to out.
Throws:
  `DataLengthException` - if the output buffer is too small.
  `java.lang.IllegalStateException`

#### processBytes

    public int processBytes(byte[] in,
                   int inOff,
                   int inLen,
                   byte[] out,
                   int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

Description copied from interface: `AEADBlockCipher`
process a block of bytes from in putting the result into out.

Specified by:
  `processBytes` in interface `AEADBlockCipher`
Parameters:
  `in` - the input byte array.
  `inOff` - the offset into the in array where the data to be processed starts.
  `inLen` - the number of bytes to be processed.
  `out` - the output buffer the processed bytes go into.
  `outOff` - the offset into the output byte array the processed data starts at.
Returns:
  the number of bytes written to out.
Throws:
  `DataLengthException` - if the output buffer is too small.
  `java.lang.IllegalStateException`

#### doFinal

    public int doFinal(byte[] out,
              int outOff)
                throws java.lang.IllegalStateException,
                       InvalidCipherTextException

Description copied from interface: `AEADBlockCipher`
Finish the operation either appending or verifying the MAC at the end of the data.

Specified by:
  `doFinal` in interface `AEADBlockCipher`
Parameters:
  `out` - space for any resulting output data.
  `outOff` - offset into out to start copying the data at.
Returns:
  number of bytes written into out.
Throws:
  `java.lang.IllegalStateException` - if the cipher is in an inappropriate state.
  `InvalidCipherTextException` - if the MAC fails to match.

#### reset

    public void reset()

Description copied from interface: `AEADBlockCipher`
Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).

Specified by:
  `reset` in interface `AEADBlockCipher`

#### getMac

    public byte[] getMac()

Returns a byte array containing the mac calculated as part of the last encrypt or decrypt operation.

Specified by:
  `getMac` in interface `AEADBlockCipher`
Returns:
  the last mac calculated.

#### getUpdateOutputSize

    public int getUpdateOutputSize(int len)

Description copied from interface: `AEADBlockCipher`
return the size of the output buffer required for a processBytes an input of len bytes.

Specified by:
  `getUpdateOutputSize` in interface `AEADBlockCipher`
Parameters:
  `len` - the length of the input.
Returns:
  the space required to accommodate a call to processBytes with len bytes of input.

#### getOutputSize

    public int getOutputSize(int len)

Description copied from interface: `AEADBlockCipher`
return the size of the output buffer required for a processBytes plus a doFinal with an input of len bytes.

Specified by:
  `getOutputSize` in interface `AEADBlockCipher`
Parameters:
  `len` - the length of the input.
Returns:
  the space required to accommodate a call to processBytes and doFinal with len bytes of input.

#### processPacket

    public byte[] processPacket(byte[] in,
                       int inOff,
                       int inLen)
                         throws java.lang.IllegalStateException,
                                InvalidCipherTextException

Throws:
  `java.lang.IllegalStateException`
  `InvalidCipherTextException`